-- Setup Character table/namespace.
rawset(_G,"cfChars",{})
-- Copies of ingame variables
cfChars.firstRainbowColor = SKINCOLOR_PINK

-- C function ported to lua, which was originally ported from lua to C
-- fuck me
-- this isn't even used in the release im crying
---@param v drawer
---@param c camera_t
---@param p player_t
---@param rev bool weather to check the opposite direction or not
---@return result table{x,y,scale,onscreen,angle,pitch,fov}
function cfChars.objectTracking(v,c,p,point,rev)
	local viewid = cfChars.getSplitscreenPlayerID(p)
	local viewang,viewaim,viewroll,
	scrw,scrh,scrhw,scrhh,
	fovdiff,fov,fovtan,fg,
	h,da,dp
	local basefov = 90*FRACUNIT
	local result = {x=0,y=0,scale=FRACUNIT,onscreen=false,angle,pitch,fov}
	
	local scrdupx,scrdupfx = v.dupx()
	local scrdupy,scrdupfy = v.dupy()
	
	if(rev)then
		viewang = c.angle + ANGLE_180
		viewaim = InvAngle(c.aiming)
		viewroll = p.viewrollangle
	else
		viewang = c.angle
		viewaim = c.aiming
		viewroll = InvAngle(p.viewrollangle)
	end
	-- Screen calc
	scrw,scrh = v.width()/scrdupx,v.height()/scrdupy
	
	if(splitscreen >= 2)then
		scrw = $>>1
	end
	if(splitscreen >= 1)then
		scrh = $>>1
	end
	
	scrhw,scrhh = (scrw>>1)<<FRACBITS,(scrh>>1)<<FRACBITS
	-- FOV adjustments
	local addto = ""
	if(viewid > 0)then addto = tostring(viewid + 1) end
	fovdiff = CV_FindVar("fov"..addto).value - basefov
	fov = ((basefov - fovdiff)/2)
	fovtan = tan(FixedAngle(fov))
	
	if(splitscreen == 1)then
		fovtan = 10*$/17
	end
	
	fg = (scrw >> 1) * fovtan
	-- Viewpoint Factors
	h = R_PointToDist2(point.x,point.y,c.x,c.y)
	da = viewang - R_PointToAngle2(c.x,c.y,point.x,point.y)
	dp = viewaim - R_PointToAngle2(0,0,h,c.z)
	
	if(rev)then da = -da end
	-- Result (relative to top left)
	result.x = FixedMul(tan(da),fg)
	result.y = FixedMul((tan(viewaim)-FixedDiv(point.z - c.z,1 + FixedMul(cos(da),h))),fg)
	
	result.angle = da
	result.pitch = dp
	result.fov = fg
	
	-- rotate
	if(viewroll)then
		local tempx = result.x
		viewroll = $ >> 19
		result.x = FixedMul(cos(viewroll),tempx) - FixedMul(sin(viewroll),result.y)
		result.y = FixedMul(sin(viewroll),tempx) + FixedMul(cos(viewroll),result.y)
	end
	
	-- Flipped
	if(encoremode)then
		result.x = -$
	end
	
	-- Center
	result.x = $+scrhw
	result.y = $+scrhh
	
	result.scale = FixedDiv(scrhw,h+1)
	
	result.onscreen =  not ((abs(da) > ANG60) or (abs(viewaim - R_PointToAngle2(0,0,h,(c.z-point.z))) > ANGLE_45))
	
	-- split-screen hack
	if(result.x < 0 or result.x > (scrw<<FRACBITS))then
		result.onscreen = false
	end
	if(result.y < 0 or result.y > (scrh<<FRACBITS))then
		result.onscreen = false
	end
	
	-- adjust to non-green-res screen coords
	result.x = $-((v.width()/scrdupx) - 320)<<(FRACBITS-1)
	result.y = $-((v.height()/scrdupy) - 200)<<(FRACBITS-1)
	
	return result
end

---@param p player_t
function cfChars.getSplitscreenPlayerID(p)
	local i = 0
	for d in displayplayers.iterate() do
		if(d==p)then return i end
		i = $+1
	end
	return nil
end

---@param spid int splitscreen player's id
---@return table{x,y,flags}
function cfChars.getSplitscreenOffset(v,spid)
	local scrw,scrh = v.width(),v.height()
	local dupx,fdupx = v.dupx()
	local dupy,fdupy = v.dupy()
	local scrhw,scrhh = (scrw/(dupx*2))<<FRACBITS,(scrh/(dupy*2))<<FRACBITS
	if(splitscreen == 1)then
		return (spid) and {x=0,y=scrhh,flags=V_SNAPTOBOTTOM} or {x=0,y=0,flags=V_SNAPTOTOP}
	else
		local pos = {x=0,y=0,flags=V_SNAPTOLEFT|V_SNAPTOTOP}
		if(spid & 1)then 
			pos.x = scrhw
			pos.flags = ($&~V_SNAPTOLEFT)|V_SNAPTORIGHT
		end
		if(spid > 1)then 
			pos.y = scrhh 
			pos.flags = ($&~V_SNAPTOTOP)|V_SNAPTOBOTTOM
		end
		return pos
	end
end

function cfChars.K_RainbowColor(t)
	return cfChars.firstRainbowColor + (t % (FIRSTSUPERCOLOR - cfChars.firstRainbowColor))
end

function cfChars.ringBurst(mo,rings,force,norand,runFunc)
	if(not rings)then return end -- no rings to burst
	if(force == nil or force < 0)then
		force = FRACUNIT * 2
	end
	local raniangs = {}
	for i=1,((rings/8)+1) do
		raniangs[#raniangs+1] = P_RandomFixed()
	end
	local i = 0
	while(i < rings)
		local newnum = i % 8
		local row = i / 8
		local rotationlerp = FixedDiv((newnum+1)*FRACUNIT,min(rings-(8*row),8)*FRACUNIT)
		local new_mo = P_SpawnMobjFromMobj(mo,0,0,0,MT_FLINGRING)
		P_InstaThrust(new_mo,FixedAngle(FixedMul(360*FRACUNIT,rotationlerp))+FixedAngle(raniangs[row+1]*360),(4 - row) * force)
		P_SetObjectMomZ(new_mo,(row + 1) * FRACUNIT * 8,false)
		new_mo.threshold = 10
		i = $+1
		if(type(runFunc) == "function")then
			runFunc(new_mo,i)
		end
	end
end