--[[ RIVAL SONIC INIT ]]--
--[[ Freeslot & Init ]]--

cfChars.rivalsonic = {}
local rs = cfChars.rivalsonic


--[[ HUD ]]--

function rs.hud(v,p,c)
	if(not cheatThisRace)then return end
	-- Cache patches
	rs.patch = $ or {
		rivalTag = {v.cachePatch("K_RIVAL1"),v.cachePatch("K_RIVAL2")}
	}
	-- Rival text
	local order = {}
	for np in players.iterate do
		if(not np.valid)then continue end
		if(not np.mo or not np.mo.valid)then continue end
		if(np.spectator)then continue end
		if(skins[np.skin].name ~= "rivalsonic")then continue end
		if(R_PointToDist(np.mo.x,np.mo.y) > 8192*np.mo.scale)then continue end
		if(not P_CheckSight(p.mo,np.mo))then continue end
		table.insert(order,np)
	end
	table.sort(order,function(a,b)
		local dist1,dist2 = R_PointToDist(a.mo.x,a.mo.y),R_PointToDist(b.mo.x,b.mo.y)
		return dist1>dist2
	end)
	local splitplayer = cfChars.getSplitscreenPlayerID(p)
	local offset = cfChars.getSplitscreenOffset(v,splitplayer)
	for i,np in ipairs(order) do
		local point = {
			x=np.mo.x,
			y=np.mo.y,
			z=np.mo.z+np.mo.height
		}
		local result = cfChars.objectTracking(v,c,p,point)
		if(not result.onscreen)then continue end
		result.x,result.y = $+offset.x,$+offset.y
		v.drawScaled(result.x,result.y,FRACUNIT,rs.patch.rivalTag[((leveltime / 7) & 1) + 1],nil)
	end
end

hud.add(rs.hud,"game")