-- Everything here is written by SuperSonicNK
-- ChrisFurry only made it's functions global.
if(rawget(_G,"ssnk_patchstringsapi1"))then return end

local ssnkps = {}

function ssnkps.cache(d, spacewidth, sep, lumpname, charstring)
	local bytetable = {string.byte(charstring, 1, #charstring)}
	local f = {p = {}, sw = spacewidth, s = sep}
	for _, b in ipairs(bytetable) do
		local byte_str = tostring(b)
		while #byte_str < 3 do
			byte_str = "0"..$
		end
		local full_lump = lumpname..byte_str
		if not d.patchExists(full_lump) then 
			print("could not cache "..full_lump)
			continue 
		end
		f.p[b] = d.cachePatch(full_lump)
	end
	return f
end

function ssnkps.drawString(d, x, y, font, str, flags, colormap)
	local x_accumulator = 0
	local bytes = {string.byte(str, 1, #str)}
	for _, b in ipairs(bytes) do
		local patch = font.p[b]
		if patch == nil then
			x_accumulator = $ + (font.sw<<FRACBITS)
			continue
		end
		d.drawScaled( (x<<FRACBITS)+x_accumulator, y<<FRACBITS, FRACUNIT, patch, flags, colormap)
		x_accumulator = $ + patch.width<<FRACBITS + (font.s<<FRACBITS)
	end
end

function ssnkps.lenString(font, str)
	local x_accumulator = 0
	local bytes = {string.byte(str, 1, #str)}
	for _, b in ipairs(bytes) do
		local patch = font.p[b]
		if patch == nil then
			x_accumulator = $ + (font.sw<<FRACBITS)
			continue
		end
		x_accumulator = $ + patch.width<<FRACBITS + (font.s<<FRACBITS)
	end
	return x_accumulator
end

rawset(_G,"ssnk_patchstringsapi1",true)
rawset(_G,"ssnkPatchString",ssnkps)